
_Main_Init:

;electronique_interface_midi_006_16f628.mpas,56 :: 		begin
;electronique_interface_midi_006_16f628.mpas,57 :: 		CMCON := CMCON or $07;     // turn off comparators
	MOVLW      7
	IORWF      CMCON+0, 1
;electronique_interface_midi_006_16f628.mpas,58 :: 		OPTION_REG := 0;
	CLRF       OPTION_REG+0
;electronique_interface_midi_006_16f628.mpas,59 :: 		OPTION_REG.NOT_RBPU := 0;  // enable pullup
	BCF        OPTION_REG+0, 7
;electronique_interface_midi_006_16f628.mpas,60 :: 		INTCON := $00;
	CLRF       INTCON+0
;electronique_interface_midi_006_16f628.mpas,61 :: 		TRISA := %11111111;
	MOVLW      255
	MOVWF      TRISA+0
;electronique_interface_midi_006_16f628.mpas,62 :: 		TRISB := %11111011;
	MOVLW      251
	MOVWF      TRISB+0
;electronique_interface_midi_006_16f628.mpas,63 :: 		PORTA := $00;
	CLRF       PORTA+0
;electronique_interface_midi_006_16f628.mpas,64 :: 		PORTB := $00;
	CLRF       PORTB+0
;electronique_interface_midi_006_16f628.mpas,67 :: 		TXSTA.TX9 := 0;     // 8-bits transmission
	BCF        TXSTA+0, 6
;electronique_interface_midi_006_16f628.mpas,68 :: 		TXSTA.TXEN := 1;    // Tx enabled
	BSF        TXSTA+0, 5
;electronique_interface_midi_006_16f628.mpas,69 :: 		RCSTA := 0;
	CLRF       RCSTA+0
;electronique_interface_midi_006_16f628.mpas,70 :: 		UART1_Init(31250);  // speed for MIDI communication
	MOVLW      23
	MOVWF      SPBRG+0
	BSF        TXSTA+0, 2
	CALL       _UART1_Init+0
;electronique_interface_midi_006_16f628.mpas,71 :: 		Delay_ms(100);      // let UART stabilise
	MOVLW      2
	MOVWF      R11+0
	MOVLW      134
	MOVWF      R12+0
	MOVLW      153
	MOVWF      R13+0
L__Main_Init1:
	DECFSZ     R13+0, 1
	GOTO       L__Main_Init1
	DECFSZ     R12+0, 1
	GOTO       L__Main_Init1
	DECFSZ     R11+0, 1
	GOTO       L__Main_Init1
;electronique_interface_midi_006_16f628.mpas,73 :: 		TrigData[0].TrigEnabled := true;
	MOVLW      255
	MOVWF      _TrigData+5
;electronique_interface_midi_006_16f628.mpas,74 :: 		TrigData[1].TrigEnabled := true;
	MOVLW      255
	MOVWF      _TrigData+11
;electronique_interface_midi_006_16f628.mpas,75 :: 		TrigData[2].TrigEnabled := true;
	MOVLW      255
	MOVWF      _TrigData+17
;electronique_interface_midi_006_16f628.mpas,76 :: 		TrigData[3].TrigEnabled := true;
	MOVLW      255
	MOVWF      _TrigData+23
;electronique_interface_midi_006_16f628.mpas,77 :: 		TrigData[0].OldValue := false;
	CLRF       _TrigData+0
;electronique_interface_midi_006_16f628.mpas,78 :: 		TrigData[1].OldValue := false;
	CLRF       _TrigData+6
;electronique_interface_midi_006_16f628.mpas,79 :: 		TrigData[2].OldValue := false;
	CLRF       _TrigData+12
;electronique_interface_midi_006_16f628.mpas,80 :: 		TrigData[3].OldValue := false;
	CLRF       _TrigData+18
;electronique_interface_midi_006_16f628.mpas,82 :: 		bSwProg := false;
	CLRF       _bSwProg+0
;electronique_interface_midi_006_16f628.mpas,83 :: 		bSwDown := false;
	CLRF       _bSwDown+0
;electronique_interface_midi_006_16f628.mpas,84 :: 		bSwUp := false;
	CLRF       _bSwUp+0
;electronique_interface_midi_006_16f628.mpas,86 :: 		end;
	RETURN
; end of _Main_Init

_MIDI_Note_Play:

;electronique_interface_midi_006_16f628.mpas,89 :: 		begin
;electronique_interface_midi_006_16f628.mpas,90 :: 		UART1_Write(Data1);
	MOVF       FARG_MIDI_Note_Play_Data1+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_interface_midi_006_16f628.mpas,91 :: 		UART1_Write(Data2);
	MOVF       FARG_MIDI_Note_Play_Data2+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_interface_midi_006_16f628.mpas,92 :: 		UART1_Write(Data3);
	MOVF       FARG_MIDI_Note_Play_Data3+0, 0
	MOVWF      FARG_UART1_Write_data_+0
	CALL       _UART1_Write+0
;electronique_interface_midi_006_16f628.mpas,93 :: 		end;
	RETURN
; end of _MIDI_Note_Play

_Note_DoDelay:

;electronique_interface_midi_006_16f628.mpas,96 :: 		begin
;electronique_interface_midi_006_16f628.mpas,98 :: 		if In_Prog then
	BTFSS      RA5_bit+0, 5
	GOTO       L__Note_DoDelay5
;electronique_interface_midi_006_16f628.mpas,100 :: 		Delay_ms(50);    // 50 ms
	MOVLW      195
	MOVWF      R12+0
	MOVLW      205
	MOVWF      R13+0
L__Note_DoDelay7:
	DECFSZ     R13+0, 1
	GOTO       L__Note_DoDelay7
	DECFSZ     R12+0, 1
	GOTO       L__Note_DoDelay7
;electronique_interface_midi_006_16f628.mpas,101 :: 		end
	GOTO       L__Note_DoDelay6
;electronique_interface_midi_006_16f628.mpas,102 :: 		else
L__Note_DoDelay5:
;electronique_interface_midi_006_16f628.mpas,106 :: 		if In_Set_Delay then
	BTFSS      RA4_bit+0, 4
	GOTO       L__Note_DoDelay9
;electronique_interface_midi_006_16f628.mpas,107 :: 		Delay_ms(500)    // 1/2 s
	MOVLW      8
	MOVWF      R11+0
	MOVLW      157
	MOVWF      R12+0
	MOVLW      5
	MOVWF      R13+0
L__Note_DoDelay11:
	DECFSZ     R13+0, 1
	GOTO       L__Note_DoDelay11
	DECFSZ     R12+0, 1
	GOTO       L__Note_DoDelay11
	DECFSZ     R11+0, 1
	GOTO       L__Note_DoDelay11
	NOP
	NOP
	GOTO       L__Note_DoDelay10
;electronique_interface_midi_006_16f628.mpas,108 :: 		else
L__Note_DoDelay9:
;electronique_interface_midi_006_16f628.mpas,109 :: 		Delay_ms(50);    // 50 ms
	MOVLW      195
	MOVWF      R12+0
	MOVLW      205
	MOVWF      R13+0
L__Note_DoDelay12:
	DECFSZ     R13+0, 1
	GOTO       L__Note_DoDelay12
	DECFSZ     R12+0, 1
	GOTO       L__Note_DoDelay12
L__Note_DoDelay10:
;electronique_interface_midi_006_16f628.mpas,110 :: 		end;
L__Note_DoDelay6:
;electronique_interface_midi_006_16f628.mpas,111 :: 		end;
	RETURN
; end of _Note_DoDelay

_Main_Welcome:

;electronique_interface_midi_006_16f628.mpas,114 :: 		begin
;electronique_interface_midi_006_16f628.mpas,116 :: 		MIDI_Note_Play(cMIDI_Note_On, cMIDI_Note_Pitch_Do3, 100);
	MOVLW      144
	MOVWF      FARG_MIDI_Note_Play_Data1+0
	MOVLW      60
	MOVWF      FARG_MIDI_Note_Play_Data2+0
	MOVLW      100
	MOVWF      FARG_MIDI_Note_Play_Data3+0
	CALL       _MIDI_Note_Play+0
;electronique_interface_midi_006_16f628.mpas,118 :: 		Delay_ms(100);
	MOVLW      2
	MOVWF      R11+0
	MOVLW      134
	MOVWF      R12+0
	MOVLW      153
	MOVWF      R13+0
L__Main_Welcome14:
	DECFSZ     R13+0, 1
	GOTO       L__Main_Welcome14
	DECFSZ     R12+0, 1
	GOTO       L__Main_Welcome14
	DECFSZ     R11+0, 1
	GOTO       L__Main_Welcome14
;electronique_interface_midi_006_16f628.mpas,120 :: 		MIDI_Note_Play(cMIDI_Note_Off, cMIDI_Note_Pitch_Do3, cMIDI_Vel_Off);
	MOVLW      128
	MOVWF      FARG_MIDI_Note_Play_Data1+0
	MOVLW      60
	MOVWF      FARG_MIDI_Note_Play_Data2+0
	CLRF       FARG_MIDI_Note_Play_Data3+0
	CALL       _MIDI_Note_Play+0
;electronique_interface_midi_006_16f628.mpas,121 :: 		end;
	RETURN
; end of _Main_Welcome

_Out_MIDI_PlayEvent:

;electronique_interface_midi_006_16f628.mpas,124 :: 		begin
;electronique_interface_midi_006_16f628.mpas,129 :: 		if In_Set_Send = 0 then
	BTFSC      RB5_bit+0, 5
	GOTO       L__Out_MIDI_PlayEvent17
;electronique_interface_midi_006_16f628.mpas,133 :: 		cMIDI_Note_On or TrigData[idx].Channel,
	MOVF       FARG_Out_MIDI_PlayEvent_idx+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVF       R0+0, 0
	ADDLW      _TrigData+0
	MOVWF      R1+0
	MOVLW      4
	ADDWF      R1+0, 0
	MOVWF      FSR
	MOVLW      144
	IORWF      INDF+0, 0
	MOVWF      FARG_MIDI_Note_Play_Data1+0
;electronique_interface_midi_006_16f628.mpas,134 :: 		TrigData[idx].Pitch,
	MOVF       R0+0, 0
	ADDLW      _TrigData+0
	MOVWF      R1+0
	MOVLW      3
	ADDWF      R1+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      FARG_MIDI_Note_Play_Data2+0
;electronique_interface_midi_006_16f628.mpas,135 :: 		TrigData[idx].Velocity);
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      2
	ADDWF      R0+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      FARG_MIDI_Note_Play_Data3+0
	CALL       _MIDI_Note_Play+0
;electronique_interface_midi_006_16f628.mpas,137 :: 		Note_DoDelay;
	CALL       _Note_DoDelay+0
;electronique_interface_midi_006_16f628.mpas,140 :: 		cMIDI_Note_Off or TrigData[idx].Channel,
	MOVF       FARG_Out_MIDI_PlayEvent_idx+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVF       R0+0, 0
	ADDLW      _TrigData+0
	MOVWF      R1+0
	MOVLW      4
	ADDWF      R1+0, 0
	MOVWF      FSR
	MOVLW      128
	IORWF      INDF+0, 0
	MOVWF      FARG_MIDI_Note_Play_Data1+0
;electronique_interface_midi_006_16f628.mpas,141 :: 		TrigData[idx].Pitch,
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      3
	ADDWF      R0+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      FARG_MIDI_Note_Play_Data2+0
;electronique_interface_midi_006_16f628.mpas,142 :: 		cMIDI_Vel_Off);
	CLRF       FARG_MIDI_Note_Play_Data3+0
	CALL       _MIDI_Note_Play+0
;electronique_interface_midi_006_16f628.mpas,143 :: 		end
	GOTO       L__Out_MIDI_PlayEvent18
;electronique_interface_midi_006_16f628.mpas,144 :: 		else
L__Out_MIDI_PlayEvent17:
;electronique_interface_midi_006_16f628.mpas,148 :: 		cMIDI_CC or TrigData[idx].Channel,
	MOVF       FARG_Out_MIDI_PlayEvent_idx+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVF       R0+0, 0
	ADDLW      _TrigData+0
	MOVWF      R1+0
	MOVLW      4
	ADDWF      R1+0, 0
	MOVWF      FSR
	MOVLW      176
	IORWF      INDF+0, 0
	MOVWF      FARG_MIDI_Note_Play_Data1+0
;electronique_interface_midi_006_16f628.mpas,149 :: 		TrigData[idx].Pitch,
	MOVF       R0+0, 0
	ADDLW      _TrigData+0
	MOVWF      R1+0
	MOVLW      3
	ADDWF      R1+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      FARG_MIDI_Note_Play_Data2+0
;electronique_interface_midi_006_16f628.mpas,150 :: 		TrigData[idx].Velocity);
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      2
	ADDWF      R0+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      FARG_MIDI_Note_Play_Data3+0
	CALL       _MIDI_Note_Play+0
;electronique_interface_midi_006_16f628.mpas,152 :: 		Note_DoDelay;
	CALL       _Note_DoDelay+0
;electronique_interface_midi_006_16f628.mpas,153 :: 		end;
L__Out_MIDI_PlayEvent18:
;electronique_interface_midi_006_16f628.mpas,155 :: 		end;
	RETURN
; end of _Out_MIDI_PlayEvent

_Main_HandlePulse:

;electronique_interface_midi_006_16f628.mpas,158 :: 		begin
;electronique_interface_midi_006_16f628.mpas,160 :: 		if (TrigData[idx].NewValue > TrigData[idx].OldValue) and
	MOVF       FARG_Main_HandlePulse_idx+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVF       R0+0, 0
	ADDLW      _TrigData+0
	MOVWF      R1+0
	INCF       R1+0, 0
	MOVWF      R3+0
	MOVF       R0+0, 0
	ADDLW      _TrigData+0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R2+0
	MOVF       R3+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	SUBWF      R2+0, 0
	MOVLW      255
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R1+0
;electronique_interface_midi_006_16f628.mpas,161 :: 		(TrigData[idx].TrigEnabled = true) then
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      5
	ADDWF      R0+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      255
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R0+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__Main_HandlePulse21
;electronique_interface_midi_006_16f628.mpas,162 :: 		Out_MIDI_PlayEvent(idx);
	MOVF       FARG_Main_HandlePulse_idx+0, 0
	MOVWF      FARG_Out_MIDI_PlayEvent_idx+0
	CALL       _Out_MIDI_PlayEvent+0
L__Main_HandlePulse21:
;electronique_interface_midi_006_16f628.mpas,163 :: 		end;
	RETURN
; end of _Main_HandlePulse

_Notes_Load:

;electronique_interface_midi_006_16f628.mpas,168 :: 		begin
;electronique_interface_midi_006_16f628.mpas,169 :: 		for i := 0 to 3 do
	CLRF       _i+0
L__Notes_Load25:
;electronique_interface_midi_006_16f628.mpas,172 :: 		iTmp := EEProm_Read(i);
	MOVF       _i+0, 0
	MOVWF      FARG_EEPROM_Read_address+0
	CALL       _EEPROM_Read+0
	MOVF       R0+0, 0
	MOVWF      Notes_Load_iTmp+0
;electronique_interface_midi_006_16f628.mpas,174 :: 		if iTmp > 127 then
	MOVF       R0+0, 0
	SUBLW      127
	BTFSC      STATUS+0, 0
	GOTO       L__Notes_Load30
;electronique_interface_midi_006_16f628.mpas,177 :: 		0 : TrigData[i].Pitch := cMIDI_Note_Pitch_Do3;  // (Do3 defaut value)
	MOVF       _i+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__Notes_Load35
	MOVF       _i+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      3
	ADDWF      R0+0, 0
	MOVWF      FSR
	MOVLW      60
	MOVWF      INDF+0
	GOTO       L__Notes_Load32
L__Notes_Load35:
;electronique_interface_midi_006_16f628.mpas,178 :: 		1 : TrigData[i].Pitch := cMIDI_Note_Pitch_Re3;  // (Re3 defaut value)
	MOVF       _i+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__Notes_Load38
	MOVF       _i+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      3
	ADDWF      R0+0, 0
	MOVWF      FSR
	MOVLW      62
	MOVWF      INDF+0
	GOTO       L__Notes_Load32
L__Notes_Load38:
;electronique_interface_midi_006_16f628.mpas,179 :: 		2 : TrigData[i].Pitch := cMIDI_Note_Pitch_Mi3;  // (Mi3 defaut value)
	MOVF       _i+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__Notes_Load41
	MOVF       _i+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      3
	ADDWF      R0+0, 0
	MOVWF      FSR
	MOVLW      64
	MOVWF      INDF+0
	GOTO       L__Notes_Load32
L__Notes_Load41:
;electronique_interface_midi_006_16f628.mpas,180 :: 		3 : TrigData[i].Pitch := cMIDI_Note_Pitch_Fa3;  // (Fa3 defaut value)
	MOVF       _i+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L__Notes_Load44
	MOVF       _i+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      3
	ADDWF      R0+0, 0
	MOVWF      FSR
	MOVLW      65
	MOVWF      INDF+0
	GOTO       L__Notes_Load32
L__Notes_Load44:
L__Notes_Load32:
;electronique_interface_midi_006_16f628.mpas,182 :: 		end
	GOTO       L__Notes_Load31
;electronique_interface_midi_006_16f628.mpas,183 :: 		else
L__Notes_Load30:
;electronique_interface_midi_006_16f628.mpas,186 :: 		TrigData[i].Pitch := iTmp;
	MOVF       _i+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      3
	ADDWF      R0+0, 0
	MOVWF      FSR
	MOVF       Notes_Load_iTmp+0, 0
	MOVWF      INDF+0
;electronique_interface_midi_006_16f628.mpas,187 :: 		end;
L__Notes_Load31:
;electronique_interface_midi_006_16f628.mpas,190 :: 		iTmp := EEProm_Read(i + 4);
	MOVLW      4
	ADDWF      _i+0, 0
	MOVWF      FARG_EEPROM_Read_address+0
	CALL       _EEPROM_Read+0
	MOVF       R0+0, 0
	MOVWF      Notes_Load_iTmp+0
;electronique_interface_midi_006_16f628.mpas,192 :: 		if iTmp > 127 then
	MOVF       R0+0, 0
	SUBLW      127
	BTFSC      STATUS+0, 0
	GOTO       L__Notes_Load46
;electronique_interface_midi_006_16f628.mpas,193 :: 		TrigData[i].Velocity := 100  // defaut value
	MOVF       _i+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      2
	ADDWF      R0+0, 0
	MOVWF      FSR
	MOVLW      100
	MOVWF      INDF+0
	GOTO       L__Notes_Load47
;electronique_interface_midi_006_16f628.mpas,195 :: 		else
L__Notes_Load46:
;electronique_interface_midi_006_16f628.mpas,196 :: 		TrigData[i].velocity := iTmp;
	MOVF       _i+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      2
	ADDWF      R0+0, 0
	MOVWF      FSR
	MOVF       Notes_Load_iTmp+0, 0
	MOVWF      INDF+0
L__Notes_Load47:
;electronique_interface_midi_006_16f628.mpas,199 :: 		iTmp := EEProm_Read(i + 8);
	MOVLW      8
	ADDWF      _i+0, 0
	MOVWF      FARG_EEPROM_Read_address+0
	CALL       _EEPROM_Read+0
	MOVF       R0+0, 0
	MOVWF      Notes_Load_iTmp+0
;electronique_interface_midi_006_16f628.mpas,201 :: 		if iTmp > 15 then
	MOVF       R0+0, 0
	SUBLW      15
	BTFSC      STATUS+0, 0
	GOTO       L__Notes_Load49
;electronique_interface_midi_006_16f628.mpas,202 :: 		TrigData[i].Channel := 0
	MOVF       _i+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      4
	ADDWF      R0+0, 0
	MOVWF      FSR
	CLRF       INDF+0
	GOTO       L__Notes_Load50
;electronique_interface_midi_006_16f628.mpas,203 :: 		else
L__Notes_Load49:
;electronique_interface_midi_006_16f628.mpas,205 :: 		TrigData[i].Channel := iTmp;
	MOVF       _i+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      4
	ADDWF      R0+0, 0
	MOVWF      FSR
	MOVF       Notes_Load_iTmp+0, 0
	MOVWF      INDF+0
L__Notes_Load50:
;electronique_interface_midi_006_16f628.mpas,207 :: 		end;
	MOVF       _i+0, 0
	XORLW      3
	BTFSC      STATUS+0, 2
	GOTO       L__Notes_Load28
	INCF       _i+0, 1
	GOTO       L__Notes_Load25
L__Notes_Load28:
;electronique_interface_midi_006_16f628.mpas,208 :: 		end;
	RETURN
; end of _Notes_Load

_Notes_Save:

;electronique_interface_midi_006_16f628.mpas,213 :: 		begin
;electronique_interface_midi_006_16f628.mpas,214 :: 		for i := 0 to 3 do
	CLRF       _i+0
L__Notes_Save53:
;electronique_interface_midi_006_16f628.mpas,218 :: 		iTmp := TrigData[i].Pitch;
	MOVF       _i+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      3
	ADDWF      R0+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	MOVWF      Notes_Save_iTmp+0
;electronique_interface_midi_006_16f628.mpas,219 :: 		if iTmp > 127 then
	MOVF       R1+0, 0
	SUBLW      127
	BTFSC      STATUS+0, 0
	GOTO       L__Notes_Save58
;electronique_interface_midi_006_16f628.mpas,222 :: 		0 : iTmp := cMIDI_Note_Pitch_Do3;  // (Do3 defaut value)
	MOVF       _i+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__Notes_Save63
	MOVLW      60
	MOVWF      Notes_Save_iTmp+0
	GOTO       L__Notes_Save60
L__Notes_Save63:
;electronique_interface_midi_006_16f628.mpas,223 :: 		1 : iTmp := cMIDI_Note_Pitch_Re3;  // (Re3 defaut value)
	MOVF       _i+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L__Notes_Save66
	MOVLW      62
	MOVWF      Notes_Save_iTmp+0
	GOTO       L__Notes_Save60
L__Notes_Save66:
;electronique_interface_midi_006_16f628.mpas,224 :: 		2 : iTmp := cMIDI_Note_Pitch_Mi3;  // (Mi3 defaut value)
	MOVF       _i+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L__Notes_Save69
	MOVLW      64
	MOVWF      Notes_Save_iTmp+0
	GOTO       L__Notes_Save60
L__Notes_Save69:
;electronique_interface_midi_006_16f628.mpas,225 :: 		3 : iTmp := cMIDI_Note_Pitch_Fa3;  // (Fa3 defaut value)
	MOVF       _i+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L__Notes_Save72
	MOVLW      65
	MOVWF      Notes_Save_iTmp+0
	GOTO       L__Notes_Save60
L__Notes_Save72:
L__Notes_Save60:
;electronique_interface_midi_006_16f628.mpas,227 :: 		end;
L__Notes_Save58:
;electronique_interface_midi_006_16f628.mpas,228 :: 		EEProm_Write(i, iTmp);
	MOVF       _i+0, 0
	MOVWF      FARG_EEPROM_Write_address+0
	MOVF       Notes_Save_iTmp+0, 0
	MOVWF      FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
;electronique_interface_midi_006_16f628.mpas,231 :: 		iTmp := TrigData[i].Pitch;
	MOVF       _i+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      3
	ADDWF      R0+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	MOVWF      Notes_Save_iTmp+0
;electronique_interface_midi_006_16f628.mpas,232 :: 		if iTmp > 127 then    // more than 127 is not allowed
	MOVF       R1+0, 0
	SUBLW      127
	BTFSC      STATUS+0, 0
	GOTO       L__Notes_Save74
;electronique_interface_midi_006_16f628.mpas,233 :: 		iTmp := cMIDI_Note_Vel_100;  // 100, defaut value
	MOVLW      100
	MOVWF      Notes_Save_iTmp+0
L__Notes_Save74:
;electronique_interface_midi_006_16f628.mpas,234 :: 		EEProm_Write(i + 4, iTmp);
	MOVLW      4
	ADDWF      _i+0, 0
	MOVWF      FARG_EEPROM_Write_address+0
	MOVF       Notes_Save_iTmp+0, 0
	MOVWF      FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
;electronique_interface_midi_006_16f628.mpas,237 :: 		iTmp := TrigData[i].Channel;
	MOVF       _i+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      4
	ADDWF      R0+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	MOVWF      Notes_Save_iTmp+0
;electronique_interface_midi_006_16f628.mpas,238 :: 		if iTmp > 15 then
	MOVF       R1+0, 0
	SUBLW      15
	BTFSC      STATUS+0, 0
	GOTO       L__Notes_Save77
;electronique_interface_midi_006_16f628.mpas,239 :: 		iTmp := 0; // MIDI channel 1
	CLRF       Notes_Save_iTmp+0
L__Notes_Save77:
;electronique_interface_midi_006_16f628.mpas,240 :: 		EEProm_Write(i + 8, iTmp);
	MOVLW      8
	ADDWF      _i+0, 0
	MOVWF      FARG_EEPROM_Write_address+0
	MOVF       Notes_Save_iTmp+0, 0
	MOVWF      FARG_EEPROM_Write_data_+0
	CALL       _EEPROM_Write+0
;electronique_interface_midi_006_16f628.mpas,241 :: 		end;
	MOVF       _i+0, 0
	XORLW      3
	BTFSC      STATUS+0, 2
	GOTO       L__Notes_Save56
	INCF       _i+0, 1
	GOTO       L__Notes_Save53
L__Notes_Save56:
;electronique_interface_midi_006_16f628.mpas,242 :: 		end;
	RETURN
; end of _Notes_Save

_Note_Pitch_Inc:

;electronique_interface_midi_006_16f628.mpas,245 :: 		begin
;electronique_interface_midi_006_16f628.mpas,247 :: 		if TrigData[idx].Pitch < 127 then
	MOVF       FARG_Note_Pitch_Inc_idx+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      3
	ADDWF      R0+0, 0
	MOVWF      FSR
	MOVLW      127
	SUBWF      INDF+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L__Note_Pitch_Inc81
;electronique_interface_midi_006_16f628.mpas,249 :: 		TrigData[idx].Pitch := TrigData[idx].Pitch + 1;
	MOVF       FARG_Note_Pitch_Inc_idx+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVF       R0+0, 0
	ADDLW      _TrigData+0
	MOVWF      R1+0
	MOVLW      3
	ADDWF      R1+0, 1
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      3
	ADDWF      R0+0, 0
	MOVWF      FSR
	INCF       INDF+0, 0
	MOVWF      R0+0
	MOVF       R1+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
;electronique_interface_midi_006_16f628.mpas,250 :: 		bNoteChanged := true;
	MOVLW      255
	MOVWF      _bNoteChanged+0
;electronique_interface_midi_006_16f628.mpas,251 :: 		end;
L__Note_Pitch_Inc81:
;electronique_interface_midi_006_16f628.mpas,252 :: 		end;
	RETURN
; end of _Note_Pitch_Inc

_Note_Pitch_Dec:

;electronique_interface_midi_006_16f628.mpas,255 :: 		begin
;electronique_interface_midi_006_16f628.mpas,257 :: 		if TrigData[idx].Pitch > 0 then
	MOVF       FARG_Note_Pitch_Dec_idx+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      3
	ADDWF      R0+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	SUBLW      0
	BTFSC      STATUS+0, 0
	GOTO       L__Note_Pitch_Dec85
;electronique_interface_midi_006_16f628.mpas,259 :: 		TrigData[idx].Pitch := TrigData[idx].Pitch - 1;
	MOVF       FARG_Note_Pitch_Dec_idx+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVF       R0+0, 0
	ADDLW      _TrigData+0
	MOVWF      R1+0
	MOVLW      3
	ADDWF      R1+0, 1
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      3
	ADDWF      R0+0, 0
	MOVWF      FSR
	DECF       INDF+0, 0
	MOVWF      R0+0
	MOVF       R1+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
;electronique_interface_midi_006_16f628.mpas,260 :: 		bNoteChanged := true;
	MOVLW      255
	MOVWF      _bNoteChanged+0
;electronique_interface_midi_006_16f628.mpas,261 :: 		end;
L__Note_Pitch_Dec85:
;electronique_interface_midi_006_16f628.mpas,262 :: 		end;
	RETURN
; end of _Note_Pitch_Dec

_Note_Vel_Inc:

;electronique_interface_midi_006_16f628.mpas,265 :: 		begin
;electronique_interface_midi_006_16f628.mpas,267 :: 		if TrigData[idx].Velocity < 127 then
	MOVF       FARG_Note_Vel_Inc_idx+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      2
	ADDWF      R0+0, 0
	MOVWF      FSR
	MOVLW      127
	SUBWF      INDF+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L__Note_Vel_Inc89
;electronique_interface_midi_006_16f628.mpas,269 :: 		TrigData[idx].Velocity := TrigData[idx].Velocity + 1;
	MOVF       FARG_Note_Vel_Inc_idx+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVF       R0+0, 0
	ADDLW      _TrigData+0
	MOVWF      R1+0
	MOVLW      2
	ADDWF      R1+0, 1
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      2
	ADDWF      R0+0, 0
	MOVWF      FSR
	INCF       INDF+0, 0
	MOVWF      R0+0
	MOVF       R1+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
;electronique_interface_midi_006_16f628.mpas,270 :: 		bNoteChanged := true;
	MOVLW      255
	MOVWF      _bNoteChanged+0
;electronique_interface_midi_006_16f628.mpas,271 :: 		end;
L__Note_Vel_Inc89:
;electronique_interface_midi_006_16f628.mpas,272 :: 		end;
	RETURN
; end of _Note_Vel_Inc

_Note_Vel_Dec:

;electronique_interface_midi_006_16f628.mpas,275 :: 		begin
;electronique_interface_midi_006_16f628.mpas,277 :: 		if TrigData[idx].Velocity > 0 then
	MOVF       FARG_Note_Vel_Dec_idx+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      2
	ADDWF      R0+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	SUBLW      0
	BTFSC      STATUS+0, 0
	GOTO       L__Note_Vel_Dec93
;electronique_interface_midi_006_16f628.mpas,279 :: 		TrigData[idx].Velocity := TrigData[idx].Velocity - 1;
	MOVF       FARG_Note_Vel_Dec_idx+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVF       R0+0, 0
	ADDLW      _TrigData+0
	MOVWF      R1+0
	MOVLW      2
	ADDWF      R1+0, 1
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      2
	ADDWF      R0+0, 0
	MOVWF      FSR
	DECF       INDF+0, 0
	MOVWF      R0+0
	MOVF       R1+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
;electronique_interface_midi_006_16f628.mpas,280 :: 		bNoteChanged := true;
	MOVLW      255
	MOVWF      _bNoteChanged+0
;electronique_interface_midi_006_16f628.mpas,281 :: 		end;
L__Note_Vel_Dec93:
;electronique_interface_midi_006_16f628.mpas,282 :: 		end;
	RETURN
; end of _Note_Vel_Dec

_Note_Channel_Inc:

;electronique_interface_midi_006_16f628.mpas,285 :: 		begin
;electronique_interface_midi_006_16f628.mpas,287 :: 		if TrigData[idx].Channel < 15 then
	MOVF       FARG_Note_Channel_Inc_idx+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      4
	ADDWF      R0+0, 0
	MOVWF      FSR
	MOVLW      15
	SUBWF      INDF+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L__Note_Channel_Inc97
;electronique_interface_midi_006_16f628.mpas,289 :: 		TrigData[idx].Channel := TrigData[idx].Channel + 1;
	MOVF       FARG_Note_Channel_Inc_idx+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVF       R0+0, 0
	ADDLW      _TrigData+0
	MOVWF      R1+0
	MOVLW      4
	ADDWF      R1+0, 1
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      4
	ADDWF      R0+0, 0
	MOVWF      FSR
	INCF       INDF+0, 0
	MOVWF      R0+0
	MOVF       R1+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
;electronique_interface_midi_006_16f628.mpas,290 :: 		bNoteChanged := true;
	MOVLW      255
	MOVWF      _bNoteChanged+0
;electronique_interface_midi_006_16f628.mpas,291 :: 		end;
L__Note_Channel_Inc97:
;electronique_interface_midi_006_16f628.mpas,292 :: 		end;
	RETURN
; end of _Note_Channel_Inc

_Note_Channel_Dec:

;electronique_interface_midi_006_16f628.mpas,295 :: 		begin
;electronique_interface_midi_006_16f628.mpas,297 :: 		if TrigData[idx].Channel > 0 then
	MOVF       FARG_Note_Channel_Dec_idx+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      4
	ADDWF      R0+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	SUBLW      0
	BTFSC      STATUS+0, 0
	GOTO       L__Note_Channel_Dec101
;electronique_interface_midi_006_16f628.mpas,299 :: 		TrigData[idx].Channel := TrigData[idx].Channel - 1;
	MOVF       FARG_Note_Channel_Dec_idx+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVF       R0+0, 0
	ADDLW      _TrigData+0
	MOVWF      R1+0
	MOVLW      4
	ADDWF      R1+0, 1
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      4
	ADDWF      R0+0, 0
	MOVWF      FSR
	DECF       INDF+0, 0
	MOVWF      R0+0
	MOVF       R1+0, 0
	MOVWF      FSR
	MOVF       R0+0, 0
	MOVWF      INDF+0
;electronique_interface_midi_006_16f628.mpas,300 :: 		bNoteChanged := true;
	MOVLW      255
	MOVWF      _bNoteChanged+0
;electronique_interface_midi_006_16f628.mpas,301 :: 		end;
L__Note_Channel_Dec101:
;electronique_interface_midi_006_16f628.mpas,302 :: 		end;
	RETURN
; end of _Note_Channel_Dec

_Notes_Prog:

;electronique_interface_midi_006_16f628.mpas,305 :: 		begin
;electronique_interface_midi_006_16f628.mpas,309 :: 		iNoteSelected := 0;
	CLRF       _iNoteSelected+0
;electronique_interface_midi_006_16f628.mpas,311 :: 		if In_Trig_0 = 1 then
	BTFSS      RA0_bit+0, 0
	GOTO       L__Notes_Prog105
;electronique_interface_midi_006_16f628.mpas,312 :: 		iNoteSelected := 0
	CLRF       _iNoteSelected+0
	GOTO       L__Notes_Prog106
;electronique_interface_midi_006_16f628.mpas,313 :: 		else if In_Trig_1 = 1 then
L__Notes_Prog105:
	BTFSS      RA1_bit+0, 1
	GOTO       L__Notes_Prog108
;electronique_interface_midi_006_16f628.mpas,314 :: 		iNoteSelected := 1
	MOVLW      1
	MOVWF      _iNoteSelected+0
	GOTO       L__Notes_Prog109
;electronique_interface_midi_006_16f628.mpas,315 :: 		else if In_Trig_2 = 1 then
L__Notes_Prog108:
	BTFSS      RA2_bit+0, 2
	GOTO       L__Notes_Prog111
;electronique_interface_midi_006_16f628.mpas,316 :: 		iNoteSelected := 2
	MOVLW      2
	MOVWF      _iNoteSelected+0
	GOTO       L__Notes_Prog112
;electronique_interface_midi_006_16f628.mpas,317 :: 		else if In_Trig_3 = 1 then
L__Notes_Prog111:
	BTFSS      RA3_bit+0, 3
	GOTO       L__Notes_Prog114
;electronique_interface_midi_006_16f628.mpas,318 :: 		iNoteSelected := 3
	MOVLW      3
	MOVWF      _iNoteSelected+0
	GOTO       L__Notes_Prog115
;electronique_interface_midi_006_16f628.mpas,319 :: 		else
L__Notes_Prog114:
;electronique_interface_midi_006_16f628.mpas,322 :: 		if In_Set_InSel_0 = 1 then iNoteSelected := iNoteSelected + 1;
	BTFSS      RB3_bit+0, 3
	GOTO       L__Notes_Prog117
	INCF       _iNoteSelected+0, 1
L__Notes_Prog117:
;electronique_interface_midi_006_16f628.mpas,323 :: 		if In_Set_InSel_1 = 1 then iNoteSelected := iNoteSelected + 2;
	BTFSS      RB4_bit+0, 4
	GOTO       L__Notes_Prog120
	MOVLW      2
	ADDWF      _iNoteSelected+0, 1
L__Notes_Prog120:
;electronique_interface_midi_006_16f628.mpas,324 :: 		end;
L__Notes_Prog115:
L__Notes_Prog112:
L__Notes_Prog109:
L__Notes_Prog106:
;electronique_interface_midi_006_16f628.mpas,326 :: 		bNoteChanged := false;
	CLRF       _bNoteChanged+0
;electronique_interface_midi_006_16f628.mpas,329 :: 		if Button(PORTB, 6, 100, 0) and (bSwDown = false) then
	MOVLW      PORTB+0
	MOVWF      FARG_Button_port+0
	MOVLW      6
	MOVWF      FARG_Button_pin+0
	MOVLW      100
	MOVWF      FARG_Button_time+0
	CLRF       FARG_Button_activeState+0
	CALL       _Button+0
	MOVF       _bSwDown+0, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__Notes_Prog123
;electronique_interface_midi_006_16f628.mpas,331 :: 		bSwDown := true;
	MOVLW      255
	MOVWF      _bSwDown+0
;electronique_interface_midi_006_16f628.mpas,340 :: 		if ((In_Set_ParSel_0 = 0) and (In_Set_ParSel_1 = 0)) then
	BTFSC      RB0_bit+0, 0
	GOTO       L__Notes_Prog204
	BSF        114, 0
	GOTO       L__Notes_Prog205
L__Notes_Prog204:
	BCF        114, 0
L__Notes_Prog205:
	BTFSC      RB1_bit+0, 1
	GOTO       L__Notes_Prog206
	BSF        3, 0
	GOTO       L__Notes_Prog207
L__Notes_Prog206:
	BCF        3, 0
L__Notes_Prog207:
	BTFSS      114, 0
	GOTO       L__Notes_Prog208
	BTFSS      3, 0
	GOTO       L__Notes_Prog208
	BSF        114, 0
	GOTO       L__Notes_Prog209
L__Notes_Prog208:
	BCF        114, 0
L__Notes_Prog209:
	BTFSS      114, 0
	GOTO       L__Notes_Prog126
;electronique_interface_midi_006_16f628.mpas,341 :: 		Note_Channel_Dec(iNoteSelected)
	MOVF       _iNoteSelected+0, 0
	MOVWF      FARG_Note_Channel_Dec_idx+0
	CALL       _Note_Channel_Dec+0
	GOTO       L__Notes_Prog127
;electronique_interface_midi_006_16f628.mpas,343 :: 		else if ((In_Set_ParSel_0 = 1) and (In_Set_ParSel_1 = 0)) then
L__Notes_Prog126:
	BTFSC      RB0_bit+0, 0
	GOTO       L__Notes_Prog210
	BCF        114, 0
	GOTO       L__Notes_Prog211
L__Notes_Prog210:
	BSF        114, 0
L__Notes_Prog211:
	BTFSC      RB1_bit+0, 1
	GOTO       L__Notes_Prog212
	BSF        3, 0
	GOTO       L__Notes_Prog213
L__Notes_Prog212:
	BCF        3, 0
L__Notes_Prog213:
	BTFSS      114, 0
	GOTO       L__Notes_Prog214
	BTFSS      3, 0
	GOTO       L__Notes_Prog214
	BSF        114, 0
	GOTO       L__Notes_Prog215
L__Notes_Prog214:
	BCF        114, 0
L__Notes_Prog215:
	BTFSS      114, 0
	GOTO       L__Notes_Prog129
;electronique_interface_midi_006_16f628.mpas,344 :: 		Note_Pitch_Dec(iNoteSelected)
	MOVF       _iNoteSelected+0, 0
	MOVWF      FARG_Note_Pitch_Dec_idx+0
	CALL       _Note_Pitch_Dec+0
	GOTO       L__Notes_Prog130
;electronique_interface_midi_006_16f628.mpas,346 :: 		else if ((In_Set_ParSel_0 = 0) and (In_Set_ParSel_1 = 1)) then
L__Notes_Prog129:
	BTFSC      RB0_bit+0, 0
	GOTO       L__Notes_Prog216
	BSF        114, 0
	GOTO       L__Notes_Prog217
L__Notes_Prog216:
	BCF        114, 0
L__Notes_Prog217:
	BTFSC      RB1_bit+0, 1
	GOTO       L__Notes_Prog218
	BCF        3, 0
	GOTO       L__Notes_Prog219
L__Notes_Prog218:
	BSF        3, 0
L__Notes_Prog219:
	BTFSS      114, 0
	GOTO       L__Notes_Prog220
	BTFSS      3, 0
	GOTO       L__Notes_Prog220
	BSF        114, 0
	GOTO       L__Notes_Prog221
L__Notes_Prog220:
	BCF        114, 0
L__Notes_Prog221:
	BTFSS      114, 0
	GOTO       L__Notes_Prog132
;electronique_interface_midi_006_16f628.mpas,347 :: 		Note_Vel_Dec(iNoteSelected);
	MOVF       _iNoteSelected+0, 0
	MOVWF      FARG_Note_Vel_Dec_idx+0
	CALL       _Note_Vel_Dec+0
L__Notes_Prog132:
L__Notes_Prog130:
L__Notes_Prog127:
;electronique_interface_midi_006_16f628.mpas,348 :: 		end;
L__Notes_Prog123:
;electronique_interface_midi_006_16f628.mpas,349 :: 		if In_Set_Down = 1 then bSwDown := false;
	BTFSS      RB6_bit+0, 6
	GOTO       L__Notes_Prog135
	CLRF       _bSwDown+0
L__Notes_Prog135:
;electronique_interface_midi_006_16f628.mpas,352 :: 		if Button(PORTB, 7, 100, 0) and (bSwUp = false) then
	MOVLW      PORTB+0
	MOVWF      FARG_Button_port+0
	MOVLW      7
	MOVWF      FARG_Button_pin+0
	MOVLW      100
	MOVWF      FARG_Button_time+0
	CLRF       FARG_Button_activeState+0
	CALL       _Button+0
	MOVF       _bSwUp+0, 0
	XORLW      0
	MOVLW      255
	BTFSS      STATUS+0, 2
	MOVLW      0
	MOVWF      R1+0
	MOVF       R1+0, 0
	ANDWF      R0+0, 1
	BTFSC      STATUS+0, 2
	GOTO       L__Notes_Prog138
;electronique_interface_midi_006_16f628.mpas,354 :: 		bSwUp := true;
	MOVLW      255
	MOVWF      _bSwUp+0
;electronique_interface_midi_006_16f628.mpas,363 :: 		if ((In_Set_ParSel_0 = 0) and (In_Set_ParSel_1 = 0)) then
	BTFSC      RB0_bit+0, 0
	GOTO       L__Notes_Prog222
	BSF        114, 0
	GOTO       L__Notes_Prog223
L__Notes_Prog222:
	BCF        114, 0
L__Notes_Prog223:
	BTFSC      RB1_bit+0, 1
	GOTO       L__Notes_Prog224
	BSF        3, 0
	GOTO       L__Notes_Prog225
L__Notes_Prog224:
	BCF        3, 0
L__Notes_Prog225:
	BTFSS      114, 0
	GOTO       L__Notes_Prog226
	BTFSS      3, 0
	GOTO       L__Notes_Prog226
	BSF        114, 0
	GOTO       L__Notes_Prog227
L__Notes_Prog226:
	BCF        114, 0
L__Notes_Prog227:
	BTFSS      114, 0
	GOTO       L__Notes_Prog141
;electronique_interface_midi_006_16f628.mpas,364 :: 		Note_Channel_Inc(iNoteSelected)
	MOVF       _iNoteSelected+0, 0
	MOVWF      FARG_Note_Channel_Inc_idx+0
	CALL       _Note_Channel_Inc+0
	GOTO       L__Notes_Prog142
;electronique_interface_midi_006_16f628.mpas,366 :: 		else if ((In_Set_ParSel_0 = 1) and (In_Set_ParSel_1 = 0)) then
L__Notes_Prog141:
	BTFSC      RB0_bit+0, 0
	GOTO       L__Notes_Prog228
	BCF        114, 0
	GOTO       L__Notes_Prog229
L__Notes_Prog228:
	BSF        114, 0
L__Notes_Prog229:
	BTFSC      RB1_bit+0, 1
	GOTO       L__Notes_Prog230
	BSF        3, 0
	GOTO       L__Notes_Prog231
L__Notes_Prog230:
	BCF        3, 0
L__Notes_Prog231:
	BTFSS      114, 0
	GOTO       L__Notes_Prog232
	BTFSS      3, 0
	GOTO       L__Notes_Prog232
	BSF        114, 0
	GOTO       L__Notes_Prog233
L__Notes_Prog232:
	BCF        114, 0
L__Notes_Prog233:
	BTFSS      114, 0
	GOTO       L__Notes_Prog144
;electronique_interface_midi_006_16f628.mpas,367 :: 		Note_Pitch_Inc(iNoteSelected)
	MOVF       _iNoteSelected+0, 0
	MOVWF      FARG_Note_Pitch_Inc_idx+0
	CALL       _Note_Pitch_Inc+0
	GOTO       L__Notes_Prog145
;electronique_interface_midi_006_16f628.mpas,369 :: 		else if ((In_Set_ParSel_0 = 0) and (In_Set_ParSel_1 = 1)) then
L__Notes_Prog144:
	BTFSC      RB0_bit+0, 0
	GOTO       L__Notes_Prog234
	BSF        114, 0
	GOTO       L__Notes_Prog235
L__Notes_Prog234:
	BCF        114, 0
L__Notes_Prog235:
	BTFSC      RB1_bit+0, 1
	GOTO       L__Notes_Prog236
	BCF        3, 0
	GOTO       L__Notes_Prog237
L__Notes_Prog236:
	BSF        3, 0
L__Notes_Prog237:
	BTFSS      114, 0
	GOTO       L__Notes_Prog238
	BTFSS      3, 0
	GOTO       L__Notes_Prog238
	BSF        114, 0
	GOTO       L__Notes_Prog239
L__Notes_Prog238:
	BCF        114, 0
L__Notes_Prog239:
	BTFSS      114, 0
	GOTO       L__Notes_Prog147
;electronique_interface_midi_006_16f628.mpas,370 :: 		Note_Vel_Inc(iNoteSelected);
	MOVF       _iNoteSelected+0, 0
	MOVWF      FARG_Note_Vel_Inc_idx+0
	CALL       _Note_Vel_Inc+0
L__Notes_Prog147:
L__Notes_Prog145:
L__Notes_Prog142:
;electronique_interface_midi_006_16f628.mpas,371 :: 		end;
L__Notes_Prog138:
;electronique_interface_midi_006_16f628.mpas,372 :: 		if In_Set_Up = 1 then bSwUp := false;
	BTFSS      RB7_bit+0, 7
	GOTO       L__Notes_Prog150
	CLRF       _bSwUp+0
L__Notes_Prog150:
;electronique_interface_midi_006_16f628.mpas,375 :: 		if bNoteChanged then
	MOVF       _bNoteChanged+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L__Notes_Prog153
;electronique_interface_midi_006_16f628.mpas,378 :: 		Notes_Save;
	CALL       _Notes_Save+0
;electronique_interface_midi_006_16f628.mpas,380 :: 		Out_MIDI_PlayEvent(iNoteSelected);
	MOVF       _iNoteSelected+0, 0
	MOVWF      FARG_Out_MIDI_PlayEvent_idx+0
	CALL       _Out_MIDI_PlayEvent+0
;electronique_interface_midi_006_16f628.mpas,381 :: 		end;
L__Notes_Prog153:
;electronique_interface_midi_006_16f628.mpas,382 :: 		end;
	RETURN
; end of _Notes_Prog

_Main_GetMode:

;electronique_interface_midi_006_16f628.mpas,385 :: 		begin
;electronique_interface_midi_006_16f628.mpas,389 :: 		while In_Prog = 1 do
L__Main_GetMode157:
	BTFSS      RA5_bit+0, 5
	GOTO       L__Main_GetMode158
;electronique_interface_midi_006_16f628.mpas,390 :: 		Notes_Prog;
	CALL       _Notes_Prog+0
	GOTO       L__Main_GetMode157
L__Main_GetMode158:
;electronique_interface_midi_006_16f628.mpas,391 :: 		end;
	RETURN
; end of _Main_GetMode

_Main_ReadDigitalInputs:

;electronique_interface_midi_006_16f628.mpas,394 :: 		begin
;electronique_interface_midi_006_16f628.mpas,395 :: 		TrigData[0].OldValue := TrigData[0].NewValue;
	MOVF       _TrigData+1, 0
	MOVWF      _TrigData+0
;electronique_interface_midi_006_16f628.mpas,396 :: 		TrigData[1].OldValue := TrigData[1].NewValue;
	MOVF       _TrigData+7, 0
	MOVWF      _TrigData+6
;electronique_interface_midi_006_16f628.mpas,397 :: 		TrigData[2].OldValue := TrigData[2].NewValue;
	MOVF       _TrigData+13, 0
	MOVWF      _TrigData+12
;electronique_interface_midi_006_16f628.mpas,398 :: 		TrigData[3].OldValue := TrigData[3].NewValue;
	MOVF       _TrigData+19, 0
	MOVWF      _TrigData+18
;electronique_interface_midi_006_16f628.mpas,399 :: 		TrigData[0].NewValue := In_Trig_0;
	MOVLW      0
	BTFSC      RA0_bit+0, 0
	MOVLW      1
	MOVWF      _TrigData+1
;electronique_interface_midi_006_16f628.mpas,400 :: 		TrigData[1].NewValue := In_Trig_1;
	MOVLW      0
	BTFSC      RA1_bit+0, 1
	MOVLW      1
	MOVWF      _TrigData+7
;electronique_interface_midi_006_16f628.mpas,401 :: 		TrigData[2].NewValue := In_Trig_2;
	MOVLW      0
	BTFSC      RA2_bit+0, 2
	MOVLW      1
	MOVWF      _TrigData+13
;electronique_interface_midi_006_16f628.mpas,402 :: 		TrigData[3].NewValue := In_Trig_3;
	MOVLW      0
	BTFSC      RA3_bit+0, 3
	MOVLW      1
	MOVWF      _TrigData+19
;electronique_interface_midi_006_16f628.mpas,405 :: 		for idx := 0 to 3 do
	CLRF       _idx+0
L__Main_ReadDigitalInputs163:
;electronique_interface_midi_006_16f628.mpas,407 :: 		if (TrigData[idx].NewValue = false) then
	MOVF       _idx+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	INCF       R0+0, 0
	MOVWF      FSR
	MOVF       INDF+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__Main_ReadDigitalInputs168
;electronique_interface_midi_006_16f628.mpas,408 :: 		TrigData[idx].TrigEnabled := true;
	MOVF       _idx+0, 0
	MOVWF      R0+0
	MOVLW      6
	MOVWF      R4+0
	CALL       _Mul_8x8_U+0
	MOVLW      _TrigData+0
	ADDWF      R0+0, 1
	MOVLW      5
	ADDWF      R0+0, 0
	MOVWF      FSR
	MOVLW      255
	MOVWF      INDF+0
L__Main_ReadDigitalInputs168:
;electronique_interface_midi_006_16f628.mpas,409 :: 		end;
	MOVF       _idx+0, 0
	XORLW      3
	BTFSC      STATUS+0, 2
	GOTO       L__Main_ReadDigitalInputs166
	INCF       _idx+0, 1
	GOTO       L__Main_ReadDigitalInputs163
L__Main_ReadDigitalInputs166:
;electronique_interface_midi_006_16f628.mpas,413 :: 		if In_Trig_0 = true then
	BTFSS      RA0_bit+0, 0
	GOTO       L__Main_ReadDigitalInputs171
;electronique_interface_midi_006_16f628.mpas,415 :: 		bSwTrig0 := true;
	MOVLW      255
	MOVWF      _bSwTrig0+0
;electronique_interface_midi_006_16f628.mpas,417 :: 		Main_HandlePulse(0);
	CLRF       FARG_Main_HandlePulse_idx+0
	CALL       _Main_HandlePulse+0
;electronique_interface_midi_006_16f628.mpas,418 :: 		end;
L__Main_ReadDigitalInputs171:
;electronique_interface_midi_006_16f628.mpas,419 :: 		if In_Trig_0 = 0 then bSwTrig0 := false;
	BTFSC      RA0_bit+0, 0
	GOTO       L__Main_ReadDigitalInputs174
	CLRF       _bSwTrig0+0
L__Main_ReadDigitalInputs174:
;electronique_interface_midi_006_16f628.mpas,423 :: 		if In_Trig_1 = true then
	BTFSS      RA1_bit+0, 1
	GOTO       L__Main_ReadDigitalInputs177
;electronique_interface_midi_006_16f628.mpas,425 :: 		bSwTrig1 := true;
	MOVLW      255
	MOVWF      _bSwTrig1+0
;electronique_interface_midi_006_16f628.mpas,427 :: 		Main_HandlePulse(1);
	MOVLW      1
	MOVWF      FARG_Main_HandlePulse_idx+0
	CALL       _Main_HandlePulse+0
;electronique_interface_midi_006_16f628.mpas,428 :: 		end;
L__Main_ReadDigitalInputs177:
;electronique_interface_midi_006_16f628.mpas,429 :: 		if In_Trig_1 = 0 then bSwTrig1 := false;
	BTFSC      RA1_bit+0, 1
	GOTO       L__Main_ReadDigitalInputs180
	CLRF       _bSwTrig1+0
L__Main_ReadDigitalInputs180:
;electronique_interface_midi_006_16f628.mpas,433 :: 		if In_Trig_2 = true then
	BTFSS      RA2_bit+0, 2
	GOTO       L__Main_ReadDigitalInputs183
;electronique_interface_midi_006_16f628.mpas,435 :: 		bSwTrig2 := true;
	MOVLW      255
	MOVWF      _bSwTrig2+0
;electronique_interface_midi_006_16f628.mpas,437 :: 		Main_HandlePulse(2);
	MOVLW      2
	MOVWF      FARG_Main_HandlePulse_idx+0
	CALL       _Main_HandlePulse+0
;electronique_interface_midi_006_16f628.mpas,438 :: 		end;
L__Main_ReadDigitalInputs183:
;electronique_interface_midi_006_16f628.mpas,439 :: 		if In_Trig_2 = 0 then bSwTrig2 := false;
	BTFSC      RA2_bit+0, 2
	GOTO       L__Main_ReadDigitalInputs186
	CLRF       _bSwTrig2+0
L__Main_ReadDigitalInputs186:
;electronique_interface_midi_006_16f628.mpas,443 :: 		if In_Trig_3 = true then
	BTFSS      RA3_bit+0, 3
	GOTO       L__Main_ReadDigitalInputs189
;electronique_interface_midi_006_16f628.mpas,445 :: 		bSwTrig3 := true;
	MOVLW      255
	MOVWF      _bSwTrig3+0
;electronique_interface_midi_006_16f628.mpas,447 :: 		Main_HandlePulse(3);
	MOVLW      3
	MOVWF      FARG_Main_HandlePulse_idx+0
	CALL       _Main_HandlePulse+0
;electronique_interface_midi_006_16f628.mpas,448 :: 		end;
L__Main_ReadDigitalInputs189:
;electronique_interface_midi_006_16f628.mpas,449 :: 		if In_Trig_3 = 0 then bSwTrig3 := false;
	BTFSC      RA3_bit+0, 3
	GOTO       L__Main_ReadDigitalInputs192
	CLRF       _bSwTrig3+0
L__Main_ReadDigitalInputs192:
;electronique_interface_midi_006_16f628.mpas,451 :: 		end;
	RETURN
; end of _Main_ReadDigitalInputs

_main:

;electronique_interface_midi_006_16f628.mpas,453 :: 		begin
;electronique_interface_midi_006_16f628.mpas,454 :: 		Main_Init;
	CALL       _Main_Init+0
;electronique_interface_midi_006_16f628.mpas,455 :: 		Notes_Load;
	CALL       _Notes_Load+0
;electronique_interface_midi_006_16f628.mpas,456 :: 		delay_ms(100);
	MOVLW      2
	MOVWF      R11+0
	MOVLW      134
	MOVWF      R12+0
	MOVLW      153
	MOVWF      R13+0
L__main195:
	DECFSZ     R13+0, 1
	GOTO       L__main195
	DECFSZ     R12+0, 1
	GOTO       L__main195
	DECFSZ     R11+0, 1
	GOTO       L__main195
;electronique_interface_midi_006_16f628.mpas,457 :: 		Main_Welcome;
	CALL       _Main_Welcome+0
;electronique_interface_midi_006_16f628.mpas,458 :: 		while true do
L__main197:
;electronique_interface_midi_006_16f628.mpas,460 :: 		if In_Prog = 1 then
	BTFSS      RA5_bit+0, 5
	GOTO       L__main202
;electronique_interface_midi_006_16f628.mpas,463 :: 		Main_GetMode;
	CALL       _Main_GetMode+0
;electronique_interface_midi_006_16f628.mpas,464 :: 		end
	GOTO       L__main203
;electronique_interface_midi_006_16f628.mpas,465 :: 		else
L__main202:
;electronique_interface_midi_006_16f628.mpas,468 :: 		Main_ReadDigitalInputs;
	CALL       _Main_ReadDigitalInputs+0
;electronique_interface_midi_006_16f628.mpas,469 :: 		end;
L__main203:
;electronique_interface_midi_006_16f628.mpas,470 :: 		end;
	GOTO       L__main197
;electronique_interface_midi_006_16f628.mpas,471 :: 		end.
	GOTO       $+0
; end of _main
